(* Type pour le programme IMP *)

type variable = string ;;
type arith_expr = 	
	| Nb of int 
	| Var of variable
	| Add of arith_expr * arith_expr 
	| Sub of arith_expr * arith_expr 
	| Mult of arith_expr * arith_expr ;;
type bool_expr =
	| True 
	| False 
	| Eq of  arith_expr * arith_expr
	| Le of arith_expr * arith_expr
	| Lt of arith_expr * arith_expr
	| Neg of bool_expr
	| And of bool_expr * bool_expr
	| Or of bool_expr * bool_expr ;;
type program = 
	| Skip
	| Aff of variable * arith_expr
	| Seq of program * program
	| Cond of bool_expr * program * program
	| While of bool_expr * program ;;
type decl = variable list ;;